local sti = require "assets/lib/sti"
love.window.setMode( 26*40,26*30, {resizable = true, fullscreen = false})

function love.load()

 map = sti("assets/data/maps/map.lua")

 
 local layer = map:addCustomLayer("Sprites")
-- Get player spawn object
    local player
    for k, object in pairs(map.objects) do
        if object.name == "Player" then
            player = object
            break
        end
    end

    -- Create player object
    local sprite = love.graphics.newImage("assets/img/sprites/sprite.png")
    layer.player = {
        sprite = sprite,
        x      = player.x,
        y      = player.y,
        ox     = sprite:getWidth() / 2,
        oy     = sprite:getHeight() / 1.35
    }
	
	    -- Add controls to player
    layer.update = function(self, dt)
        -- 300 pixels per second
        local speed = 300
		local destx, desty

        -- Move player up
        if love.keyboard.isDown("w") or love.keyboard.isDown("up") then
            self.player.y = self.player.y - speed * dt
        end

        -- Move player down
        if love.keyboard.isDown("s") or love.keyboard.isDown("down") then
            self.player.y = self.player.y + speed * dt
        end

        -- Move player left
        if love.keyboard.isDown("a") or love.keyboard.isDown("left") then
            self.player.x = self.player.x - speed * dt
        end

        -- Move player right
        if love.keyboard.isDown("d") or love.keyboard.isDown("right") then
            self.player.x = self.player.x + speed * dt
        end
		--Map:convertPixelToTile()
    end

    -- Draw player
    layer.draw = function(self)
        love.graphics.draw(
            self.player.sprite,
            math.floor(self.player.x),
            math.floor(self.player.y),
            0,
            1,
            1,
            self.player.ox,
            self.player.oy
        )
    end

    -- Remove unneeded object layer
    map:removeLayer("Spawn point")
end

function love.update(dt)
 map:update(dt)
end

fullscreen = false
function love.keypressed(key)
 if key == "f11" then
  fullscreen = not(fullscreen)
  love.window.setFullscreen(fullscreen)
 elseif key == "escape" then
  love.event.quit()
 end
end

function love.draw()
 local w, h = love.graphics.getDimensions()
 local scale = math.min(w / 200, h / 150)
 local theoreticalScale = math.min(w / 200, h / 150)
 local drawToCanvasScale = math.floor(theoreticalScale)
 local drawCanvasScale = theoreticalScale / drawToCanvasScale

    --Find map translation so player is always at the center
    local player = map.layers["Sprites"].player
    local tx = math.floor(player.x - math.floor(w / 2/scale))
    local ty = math.floor(player.y - math.floor(h / 2/scale))
	
    -- Draw world
    map:draw(-tx, -ty, drawToCanvasScale,drawCanvasScale)
end